(*
  Machine generated. Edit at your own risk 
  Reproduce with the following
 --pickler=std,sexp
 --lang=ocaml
 *)
(* module Camelot_absyn_ASDL*)
  type loc =
        Loc of (StdPrims.std_int * StdPrims.std_int)
  
  and float = (StdPrims.std_string)
  and assn = (Assertions_ASDL.assn)
  and varNm = (StdPrims.std_string)
  and tVarNmL = (loc * StdPrims.std_string)
  and tVarNm = (StdPrims.std_string)
  and ty =
        INTty
      | BOOLty
      | CHARty
      | BYTEty
      | SHORTty
      | LONGty
      | FLOATty
      | DOUBLEty
      | STRINGty
      | UNITty
      | TVARty of (tVarNm)
      | ARRAYty of (ty)
      | PRODUCTty of (ty list)
      | ARROWty of (ty * ty)
      | CONty of (ty list * StdPrims.std_string)
      | DIAMONDty of (StdPrims.std_string)
      | OBJECTty of (StdPrims.std_string)
  
  and heapUsage =
        HEAP
      | NOHEAP
  
  and typeCon =
        TYPEcon of (varNm * ty list * heapUsage)
  
  and typeConL = (loc * typeCon)
  and typeDec =
        TYPEdec of (tVarNmL list * varNm * typeConL list)
  
  and typeDecL = (loc * typeDec)
  and funAssns =
        FUNASSNS of (varNm * assn list * assn list)
  
  and hints =
        HINTS of (typeDecL list * funAssns list)
  
  and rich_constructor =
        RICH_CON of (StdPrims.std_string *
          rich_ty list *
          StdPrims.std_int)
  
  and rich_ty =
        RICH_INTty
      | RICH_BOOLty
      | RICH_CHARty
      | RICH_BYTEty
      | RICH_SHORTty
      | RICH_LONGty
      | RICH_FLOATty
      | RICH_DOUBLEty
      | RICH_STRINGty
      | RICH_UNITty
      | RICH_TVARty of (tVarNm)
      | RICH_ARRAYty of (rich_ty)
      | RICH_PRODUCTty of (rich_ty list)
      | RICH_ARROWty of (rich_ty * rich_ty)
      | RICH_CONty of (rich_ty list * varNm * rich_constructor list)
      | RICH_DIAMONDty of (StdPrims.std_string)
      | RICH_OBJECTty of (StdPrims.std_string)
      | RICH_SELFty
  
  and rich_valdec =
        RICH_VALDEC of (StdPrims.std_string *
          StdPrims.std_int *
          rich_ty *
          StdPrims.std_int)
  
  and external' =
        GLOBAL
      | LOCAL
      | BUILTIN
      | EXTERN
  
  and boolX =
        TRUEval
      | FALSEval
  
  and value =
        VARval of (varNm * external')
      | CHARval of (StdPrims.std_int)
      | INTval of (StdPrims.std_int)
      | FLOATval of (float)
      | STRINGval of (StdPrims.std_string)
      | BOOLval of (boolX)
      | UNITval
      | NULLval
  
  and unaryOperator =
        NOTop
      | ISNULLop
  
  and binaryOperator =
        PLUSop
      | MINUSop
      | TIMESop
      | DIVop
      | MODop
      | LANDop
      | LORop
      | LXORop
      | LSLop
      | LSRop
      | ASRop
      | FPLUSop
      | FMINUSop
      | FTIMESop
      | FDIVop
      | LESSop
      | LEQop
      | EQUALSop
      | CONCATop
  
  and varNmL = (loc * StdPrims.std_string)
  and matchDiam =
        NOWHERE
      | SOMEWHERE of (varNmL)
      | DISPOSE
  
  and ooMatchPat =
        CLASSpat of (varNm * varNm)
      | ANYCLASSpat
  
  and instance =
        INSTANCE
      | STATIC
  
  and valDec =
        VALdec of (varNm * ty * instance)
  
  and fieldDec =
        FIELDdec of (varNm * ty * instance)
  
  and classDec =
        CLASSdec of (varNm * varNm option * varNm list * valDec list)
  
  and varTy =
        UNITvar
      | VAR of (StdPrims.std_string * ty option)
  
  and test =
        TEST of (binaryOperator * value * value)
  
  and oomatchRule =
        OOMATCHrule of (ooMatchPat * expL)
  
  and oomatchRuleL = (loc * oomatchRule)
  and matchRule =
        MATCHrule of (varNmL * varNmL list * matchDiam * expL)
  
  and matchRuleL = (loc * matchRule)
  and expL = (loc * exp)
  and exp =
        VALexp of (value)
      | UNARYexp of (unaryOperator * value)
      | BINexp of (binaryOperator * value * value)
      | APPexp of (varNm * value list * external')
      | CONexp of (varNm * value list * varNmL option)
      | INVOKEexp of (varNm * StdPrims.std_string * value list)
      | NEWexp of (varNm * value list)
      | GETexp of (varNm * varNm)
      | SGETexp of (varNm)
      | UPDATEexp of (varNm * value)
      | SUPERMAKERexp of (value list)
      | COERCEexp of (varNm * ty)
      | LETexp of (varNm * expL * expL)
      | IFexp of (test * expL * expL)
      | MATCHexp of (varNm * matchRuleL list)
      | OOMATCHexp of (varNm * oomatchRuleL list)
      | TYPEDexp of (expL * ty)
      | ASSERTexp of (expL * assn list * assn list)
  
  and varTyL = (loc * varTy)
  and funDef =
        FUNdef of (varNm * varTyL list * instance * expL)
  
  and fieldDecL = (loc * fieldDec)
  and funDefL = (loc * funDef)
  and classDef =
        CLASSdef of (varNm *
          varNm option *
          varNm list *
          fieldDecL list *
          funDefL list)
  
  and classDecL = (loc * classDec)
  and classDefL = (loc * classDef)
  and valDecL = (loc * valDec)
  and funBlock =
        FUNblock of (funDefL list)
  
  and program =
        PROG of (typeDecL list *
          classDecL list *
          classDefL list *
          valDecL list *
          funBlock list)
  
  and valueL = (loc * value)
  and name = (StdPrims.std_string)
  

